using System;
using System.Collections.Generic;

namespace TakmicenjePetlja2
{
    class Program
    {
        
        static void Main(string[] args)
        {
            long BrojIgraca = Convert.ToInt64(Console.ReadLine());
            string broj = "";
            List<long> pozicijeX = new List<long>();
            List<long> pozicijeY = new List<long>();
            for (int i = 0; i < BrojIgraca; i++)
            {
                foreach (char item in Console.ReadLine())
                {
                    if (item != ' ') broj += item;
                    else
                    {
                        pozicijeX.Add(Convert.ToInt64(broj));
                        broj = "";
                    }
                }
                pozicijeY.Add(Convert.ToInt64(broj));
                brojevi = "";
            }
            
            int a = 0;
            for (int i = 1; i < BrojIgraca; i++) a += i - 1;
            if (Math.Abs(pozicijeX[1]) != Math.Abs(pozicijeX[2]) && Math.Abs(pozicijeX[1]) != Math.Abs(pozicijeX[3])) Console.WriteLine(Math.Pow(2, BrojIgraca) - BrojIgraca - a);
            else Console.WriteLine(0);
        }
    }
}